    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------
    028     * StandardTickUnitSource.java
    029     * ---------------------------
    030     * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardTickUnitSource.java,v 1.2.2.2 2006/01/27 13:53:28 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 23-Sep-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.axis;
    044
    045    import java.text.DecimalFormat;
    046
    047    /**
    048     * A source that can used by the {@link NumberAxis} class to obtain a
    049     * suitable {@link TickUnit}.
    050     */
    051    public class StandardTickUnitSource implements TickUnitSource {
    052
    053        /** Constant for log(10.0). */
    054        private static final double LOG_10_VALUE = Math.log(10.0);
    055
    056        /**
    057         * Returns a tick unit that is larger than the supplied unit.
    058         *
    059         * @param unit  the unit (<code>null</code> not permitted).
    060         *
    061         * @return A tick unit that is larger than the supplied unit.
    062         */
    063        public TickUnit getLargerTickUnit(TickUnit unit) {
    064            double x = unit.getSize();
    065            double log = Math.log(x) / LOG_10_VALUE;
    066            double higher = Math.ceil(log);
    067            return new NumberTickUnit(Math.pow(10, higher),
    068                    new DecimalFormat("0.0E0"));
    069        }
    070
    071        /**
    072         * Returns the tick unit in the collection that is greater than or equal
    073         * to (in size) the specified unit.
    074         *
    075         * @param unit  the unit (<code>null</code> not permitted).
    076         *
    077         * @return A unit from the collection.
    078         */
    079        public TickUnit getCeilingTickUnit(TickUnit unit) {
    080            return getLargerTickUnit(unit);
    081        }
    082
    083        /**
    084         * Returns the tick unit in the collection that is greater than or equal
    085         * to the specified size.
    086         *
    087         * @param size  the size.
    088         *
    089         * @return A unit from the collection.
    090         */
    091        public TickUnit getCeilingTickUnit(double size) {
    092            double log = Math.log(size) / LOG_10_VALUE;
    093            double higher = Math.ceil(log);
    094            return new NumberTickUnit(Math.pow(10, higher),
    095                    new DecimalFormat("0.0E0"));
    096        }
    097
    098    }